package Email::Simple::Header;
use strict;
use Carp ();
require Email::Simple;
$Email::Simple::Header::VERSION='2.005';
sub new{my($class,$head,$arg)=@_;
my$head_ref=ref$head?$head:\$head;
my$self={mycrlf=>$arg->{crlf}||"\x0d\x0a",};
my$headers=$class->_header_to_list($head_ref,$self->{mycrlf});
$self->{headers}=$headers;
bless$self=>$class;}sub _header_to_list{my($self,$head,$mycrlf)=@_;
my@headers;
my$crlf=Email::Simple->__crlf_re;
while($$head=~m/\G(.+?)$crlf/go){local$_=$1;
if(s/^\s+// or not/^([^:]+):\s*(.*)/){next if!@headers;
$headers[-1].=$headers[-1]?" $_":$_;}else{push@headers,$1,$2;}}return\@headers;}sub as_string{my($self,$arg)=@_;
$arg||={};
my$header_str='';
my$headers=$self->{headers};
my$fold_arg={at=>$self->_default_fold_at,indent=>$self->_default_fold_indent,};
for(my$i=0;$i<@$headers;$i+=2){my$header="$headers->[$i]: $headers->[$i + 1]";
$header_str.=lc$headers->[$i]eq 'content-type'?$header.$self->crlf:$self->_fold($header,$fold_arg);}return$header_str;}sub header_names{my$headers=$_[0]->{headers};
my%seen;
grep{!$seen{lc$_}++}map{$headers->[$_*2]}0..int($#$headers/2);}sub header_pairs{my($self)=@_;
return@{$self->{headers}};}sub header{my($self,$field)=@_;
my$headers=$self->{headers};
my$lc_field=lc$field;
if(wantarray){return map{@$headers[$_*2+1]}grep{lc$headers->[$_*2]eq$lc_field}0..int($#$headers/2);}else{for(0..int($#$headers/2)){return$headers->[$_*2+1]if lc$headers->[$_*2]eq$lc_field;}return;}}sub header_set{my($self,$field,@data)=@_;
if($Email::Simple::GROUCHY){Carp::croak"field name contains illegal characters" unless$field=~/^[\x21-\x39\x3b-\x7e]+$/;
Carp::carp"field name is not limited to hyphens and alphanumerics" unless$field=~/^[\w-]+$/;}my$headers=$self->{headers};
my$lc_field=lc$field;
my@indices=grep{lc$headers->[$_]eq$lc_field}map{$_*2}0..int($#$headers/2);
if(@indices>@data){my$overage=@indices-@data;
splice@{$headers},$_,2 for reverse@indices[-$overage..-1];
pop@indices for(1..$overage);}elsif(@data>@indices){my$underage=@data-@indices;
for(1..$underage){push@$headers,$field,undef;
push@indices,$#$headers-1;}}for(0..$#indices){$headers->[$indices[$_]+1]=$data[$_];}return wantarray?@data:$data[0];}sub crlf{$_[0]->{mycrlf}}sub _fold{my($self,$line,$arg)=@_;
$arg||={};
$arg->{at}=$self->_default_fold_at unless exists$arg->{at};
return$line.$self->crlf unless$arg->{at}and$arg->{at}>0;
my$limit=($arg->{at}||$self->_default_fold_at)-1;
return$line.$self->crlf if length$line<=$limit;
$arg->{indent}=$self->_default_fold_indent unless exists$arg->{indent};
my$indent=$arg->{indent}||$self->_default_fold_indent;
my$folded="";
while($line){if($line=~s/^(.{0,$limit})(\s|\z)//){$folded.=$1.$self->crlf;
$folded.=$indent if$line;}else{$folded.=$line.$self->crlf;
last;}}return$folded;}sub _default_fold_at{78}sub _default_fold_indent{" "}1;
