DirectMail.mf = DirectMail.mf || {};
var en = function (n, ord) {
  var s = String(n).split('.'), v0 = !s[1], t0 = Number(s[0]) == n,
      n10 = t0 && s[0].slice(-1), n100 = t0 && s[0].slice(-2);
  if (ord) return (n10 == 1 && n100 != 11) ? 'one'
      : (n10 == 2 && n100 != 12) ? 'two'
      : (n10 == 3 && n100 != 13) ? 'few'
      : 'other';
  return (n == 1 && v0) ? 'one' : 'other';
};
var plural = function (value, offset, lcfunc, data, isOrdinal) {
  if ({}.hasOwnProperty.call(data, value)) return data[value];
  if (offset) value -= offset;
  var key = lcfunc(value, isOrdinal);
  if (key in data) return data[key];
  return data.other;
};
var fmt = {
  number: function (value, lc, arg
  /*``*/) {
  
    var a = arg && arg.split(':') || []
    var opt = {
      integer: { maximumFractionDigits: 0 },
      percent: { style: 'percent' },
      currency: {
        style: 'currency',
        currency: a[1] && a[1].trim() || "USD",
        minimumFractionDigits: 2,
        maximumFractionDigits: 2
      }
    }
    return new Intl.NumberFormat(lc, opt[a[0]] || {}).format(value)
  
  }
};

DirectMail.mf.HistorySummary = {
  SCHEDULE_DELIVERY: function(d) { return "Schedule Delivery"; },
  RESCHEDULE_DELIVERY: function(d) { return "Reschedule Delivery"; },
  CANCELLING: function(d) { return "Canceling…"; },
  CANCEL_DELIVERY: function(d) { return "Cancel Delivery"; },
  UPDATE_ERROR_DETAILS: function(d) { return "An error occurred while updating this report: " + d.error_description; },
  UPDATE_ERROR: function(d) { return "An error occurred while updating this report."; },
  POPOVER_BOUNCES: function(d) { return d.value + " bounced (" + d.ratio + " of recipients)"; },
  POPOVER_SPAM: function(d) { return d.value + " marked as spam (" + d.ratio + " of delivered emails)"; },
  POPOVER_UNSUBSCRIBES: function(d) { return d.value + " unsubscribed (" + d.ratio + " of delivered emails)"; },
  TOOLTIP_NUM_CLICKED_LINK: function(d) { return plural(d.num_clicked, 0, en, { one: "1 recipient clicked this link", other: fmt.number(d.num_clicked, "en", "integer") + " recipients clicked this link" }); },
  POPOVER_OPENS: function(d) { return d.number_opened + " opened (" + d.open_rate + " of delivered emails, " + plural(d.number_of_views, 0, en, { one: "1 total open", other: fmt.number(d.number_of_views, "en", "integer") + " total opens" }) + ")"; },
  POPOVER_CLICKS: function(d) { return d.number_clicked + " clicked (" + d.click_rate + " of delivered emails, " + plural(d.number_of_clicks, 0, en, { one: "1 total click", other: fmt.number(d.number_of_clicks, "en", "integer") + " total clicks" }) + ")"; }
}
;
if ( fmt !== undefined ) {
    if ( window.DirectMail_nativeController !== undefined && window.DirectMail_nativeController.formatNumber !== undefined ) {
        fmt.number = function(v,lc,p) {
            return window.DirectMail_nativeController.formatNumber(v,p);
        };
    }
    else {
        var fmt_number = fmt.number;
        fmt.number = function(v,lc,p) {
            return fmt_number(v,navigator.language,p);
        };
    }
}
